#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
#define rep(i, a, n) for (int i = (a); i < (n); i++)
#define per(i, a, n) for (int i = (n) - 1; i >= (a); i--)
#define FOR(i, n) rep(i, a, (n))

int sgn(int x) {
	return (x > 0) - (x < 0);
}

void ch(vector<int>& in, vector<int>& out) {
	out[0] = sgn(in[1] - in[0]);
	out[1] = sgn(in[2] - in[1]);
	out[2] = sgn(in[2] - in[0]);
}

vector<vector<int>> labels = {
	{1,2,3},
	{1,3,2},
	{2,1,3},
	{2,3,1},
	{3,1,2},
	{3,2,1},
	{1,1,2},
	{1,2,1},
	{2,1,1},
	{2,2,1},
	{2,1,2},
	{1,2,2},
	{1,1,1},
};

unordered_map<int,vector<int>> decompose(vector<int>& v) {
	unordered_map<int,vector<int>> s;
	rep(i,0,v.size()) {
		s[v[i]].push_back(i);
	}
	return s;
}

const int INF = 1e9 + 100;

vector<int> getGreater(vector<int>& v) {
	int n = v.size();
	vector<int> res(n, -1);
	vector<pair<int,int>> st = {{n+1, INF}};
	per(i,0,n) {
		while (st.back().second <= v[i]) {
			st.pop_back();
		}
		if (st.back().first != n+1) {
			res[i] = st.back().first;
		}
		st.push_back({i, v[i]});
	}
	return res;
}

bool g111(vector<int>& x) {
	int n = v.size();
	auto dec = decompose(x);
	for(auto& a : dec) {
		if (a.second.size() >= 3) return true;
	}
	return false;
}

bool g112(vector<int>& x) {
	int n = v.size();
	auto dec = decompose(x);
	auto gre = getGreater(x);
	for(auto& a : dec) {
		if (a.second.size() < 2) continue;
		if (gre[a.second[1]] != -1) return true;
	}
	return false;
}

bool g121(vector<int>& x) {
	int n = v.size();
	auto dec = decompose(x);
	auto gre = getGreater(x);
	for(auto& a : dec) {
		if (a.second.size() < 2) continue;
		int g = gre[a[0]];
		if (g != -1 && g < a.second.back()) return true;
	}
	return false;
}

bool g123(vector<int>& x) {
	int n = v.size();
	auto gre = getGreater(x);
	vector<int> x2;
	rep(i,0,n) if (gre[i] != -1) x2.push_back(x[i]);
	auto gre2 = getGreater(x2);

	for(auto& a : gre2) {
		if (a != -1) return true;
	}
	return false;
}

int main(void)
{
	ios_base::sync_with_stdio(false);
	assert(labels.size() == 13);
	int n;
	cin >> n;
	vector<int> x(n);
	rep(i,0,n) cin >> x[i];

	vector<int> gr = getGreater(x);
	rep(i,0,gr.size()) cout << gr[i] << " "; cout << endl;

	return 0;

	vector<vector<int>> seen;

	for(auto& l : labels) {
		vector<int> cl(3);
		ch(l, cl);

		bool ok = false;
		vector<int> cur(3), curl(3);
		rep(i,0,n-2) {
			rep(j,0,3) cur[j] = x[i+j];
			ch(cur, curl);
			if (cl == curl) {
				ok = true;
				break;
			}
		}
		if (ok) {
			seen.push_back(l);
		}
	}
	sort(seen.begin(), seen.end());
	rep(i,0,seen.size()) {
		rep(j,0,3) {
			cout << seen[i][j];
		}
		cout << endl;
	}
}
